

type p     = Root of its

and  its   = ConsIts of it*its
           | NilIts

and it     = Block of its
           | Decl  of id
           | Use   of id

and id     = Ident of string

and atuple = Tuple of id*int

let rec visit_P t = match t with
        Root t_Its -> let errors = errors1 in
                      let lev1 = 0         in
                      let env1 = dclo1 in
                      let dcli1 = [] in
                      let (dclo1,errors1) = visit_Its (t_Its,dcli,env1,lev1) in
                      errors

and visit_Its (t,dcli, env, lev) = match t with
        ConsIts (t_It, t_Its) -> let lev2 = lev in
                                 let env2 = env in
                                 let dcli2 = dclo1 in
                                 let errors = concat(errors1,errors2) in
                                 let dclo = dclo2 in
                                 let lev1 = lev in
                                 let env1 = env in
                                 let dcli1 = dcli in
                                 let (dclo1,errors1) = visit_It (t_It,dcli1,env1,lev1) in 
                                 let (dclo2,errors2) = visit_Its (t_Its, dcli2, env2, lev2) in
                                 (dclo,errors)
      | NilIts                -> let errors = [] in
                                 let dclo = dcli in
                                 (dclo, errors)

and visit_It (t, dcli, env, lev) = match t with
        Block t_Its           -> let lev1 = plusOne (lev) in
                                 let env1 = dclo1 in
                                 let dcli1 = env in
                                 let errors = errors1 in
                                 let dclo = dcli in
                                 let (dclo1, errors1) = visit_Its (t_Its,dcli1,env1,lev1)
                                 in (dclo,errors)
      | Decl t_Id             -> let errors = mNBIn (t_Id, lev, dcli) in
                                 let dclo   = head (Tuple (t_Id, lev), dcli) in
                                 (dclo,errors)
      | Use t_Id              -> let errors = mBIn (t_Id, env) in
                                 let dclo = dcli in
                                 (dclo,errors);;
