
type tree = Tip  of int
          | Fork of tree*tree

and r     = RootProd of tree

let rec repmin t = match t with
                RootProd t -> let (replace1,m1) = repmin_aux (t,minIn1) in 
                              let minIn1 = m1        in
                              let replace = replace1 in
                              let m = m1             in
                              (replace,m)

and repmin_aux (t,minIn) = match t with
                        Tip n        -> let replace = Tip minIn in
                                        let m = n               in
                                        (replace,m)
                      | Fork (t1,t2) -> let (replace1,m1) = repmin_aux (t1,minIn1) in
                                        let (replace2,m2) = repmin_aux (t2,minIn2) in 
                                        let minIn1 = minIn in
                                        let minIn2 = minIn in
                                        let m = my_min (m1, m2) in
                                        let replace = Fork (replace1,replace2) in
                                        (replace,m);;

