(*
 *      Abstract Syntax
 *
 *)
type t_Id
	= C_Ident_1 of t_STR

and t_It
	= C_Block_1 of t_Its
	| C_Decl_1 of t_Id
	| C_Use_1 of t_Id

and t_Its
	= C_ConsIts_1 of t_It * t_Its
	| C_NilIts_1

and t_P
	= C_Root_1 of t_Its


(*
 *     Type of Attributes
 *
 *)
type t_Atuple
	= C_Tuple_1 of t_Id * t_INT

(*
 *      Visit Trees Data Types
 *
 *)

type ('p_lev,'t_Its_1,'p_errors,'p_t_Id) t_It_2 
	= C_Block_2  of 'p_lev * 't_Its_1
	| C_Decl_2  of 'p_errors
	| C_Use_2  of 'p_t_Id

and ('t_It_2) t_Its_2 
	= C_ConsIts_2  of 't_It_2 * (('t_It_2) t_Its_2) 
	| C_NilIts_2 

